﻿using Newtonsoft.Json.Linq;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class _11_22
    {

        public String GetSignerIdByEmail(String apiKey, String baseUrl, String packageId, String email) {
            System.Net.ServicePointManager.SecurityProtocol = SecurityProtocolType.Tls11 | SecurityProtocolType.Tls12;

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.GetAsync(new Uri(baseUrl) + "/packages/" + packageId).Result;
            JObject packageResponseJSON = JObject.Parse(response.Content.ReadAsStringAsync().Result);
            JArray rolesArray = (JArray)packageResponseJSON["roles"];
            IList<JObject> roles = rolesArray.ToObject<IList<JObject>>();
            foreach (JObject role in roles) {
                var signerEmail = role["signers"][0]["email"];
                if (signerEmail.ToString().Equals(email)) {
                    return (String)role["signers"][0]["id"];
                }
            }
            throw new Exception("Cannot find signer by email!");
        }
    }
}
